<?php
namespace MyMeals\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use MyMeals\Services\JWT;
use MyMeals\Services\DeliveryPoints as DeliveryPointsService;

class DeliveryPoints {

    const SESSION_NAME = "session";

    protected $deliverypointsService;

    public function __construct(DeliveryPointsService $deliverypointsService) {
        $this->deliverypointsService = $deliverypointsService;
    }

    public function getDeliveryPoints(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $dataSet = $this->deliverypointsService->findDeliveryPointsByMenuDate($filterCriteria);
            $response->addDataSet($dataSet);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}