<?php
namespace MyMeals\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use MyMeals\Services\JWT;
use MyMeals\Services\Plates as PlatesService;

class Plates {

    const SESSION_NAME = "session";

    protected $platesService;

    public function __construct(PlatesService $platesService) {
        $this->platesService = $platesService;
    }

    public function getPlates(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $dataSet = $this->platesService->findPlatesByMenuDate($filterCriteria);
            $response->addDataSet($dataSet);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function savePlates(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $meal = $row["meal"];
            $plates = $row["plates"];
            $this->platesService->savePlates($plates, $meal);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}