<?php
namespace MyMeals\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use MyMeals\Services\JWT;
use MyMeals\Services\Unit as UnitService;

class Unit {

    const SESSION_NAME = "session";

    protected $unitService;

    public function __construct(UnitService $unitService) {
        $this->unitService = $unitService;
    }

    public function getOperatorUnits(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $dataSet = $this->unitService->findUnitsByOperator($filterCriteria);
            $response->addDataSet($dataSet);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
} 
