describe('zhScroller', function() {

	var $compile;
	var $rootScope;
	var timeout = jasmine.createSpy('$timeout').and.callFake(function(callback, timer) {
		callback();
	});

	beforeEach(function() {
		module('ZeedhiServices');
		module('ZeedhiDirectives');

		module('ZeedhiServices', function($provide) {
			$provide.value('$timeout', timeout);
		});

		inject(function(_$compile_, _$rootScope_) {
			$compile = _$compile_;
			$rootScope = _$rootScope_;
		});
	});

	it('Scroll start should be called with a timeout of 250ms', function() {
		var scrollable = $compile('<div zh-scroller></div>')($rootScope);

		$rootScope.$apply();

		expect(timeout).toHaveBeenCalledWith(jasmine.any(Function), 250);
	}).pend('Not possible to test because element is never visible. Need to mock element to test directive');

});