function changeUnitController(ScreenService, GeneralMethods, MessageService, ChangeUnitService, templateManager) {
    var messages = {
        sameUnit: "sameUnit",
        confirmUnitChange: "confirmUnitChange"
    };
    this.onEnter = function(unitWidget) {
        unitWidget.reload();
    };

    this.changeUnit = function(unitWidget) {
        var currentRow = unitWidget.currentRow;
        if (currentRow.CDFILIAL === GeneralMethods.user.cdfilial) {
            showMessageSameUnit(currentRow.CDFILIAL, currentRow.NMFILIAL);
        } else {
            var variables = {
                UNIT: currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL
            };
            var params = {
                type: "CONFIRMATION",
                icon: "question",
                success: changeUnit.bind(currentRow)
            };
            MessageService.confirmMessageByCode(messages.confirmUnitChange, variables, params);
        }
    };

    function changeUnit() {
        ChangeUnitService.saveUserCurrentUnit(this).then(function(callback) {
            var user = callback.dataset.user;
            GeneralMethods.user.cdfilial = this.CDFILIAL;
            GeneralMethods.user.nmfilial = this.NMFILIAL;
            buildUserAndHeader(user);
            setLocalVar('Session', user.session);
            delete templateManager.containers.meals;
            ScreenService.openWindow("meals");
        }.bind(this)).catch(requestErrorCallback);
    }

    function showMessageSameUnit(unitCode, unitName) {
        var variables = {
            UNIT: unitCode + ' - ' + unitName
        };
        MessageService.showMessageByCode(messages.sameUnit, variables);
    }

}

Configuration(function(ContextRegister) {
    ContextRegister.register('ChangeUnitController', changeUnitController);
});
